// SuDokuSolverDlg.h : header file
//

#if !defined(AFX_SUDOKUSOLVERDLG_H__4055FB5E_8BCA_43FE_86CC_4713606F6CE9__INCLUDED_)
#define AFX_SUDOKUSOLVERDLG_H__4055FB5E_8BCA_43FE_86CC_4713606F6CE9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SuDoku.h"

/////////////////////////////////////////////////////////////////////////////
// CSuDokuSolverDlg dialog

class CSuDokuSolverDlg : public CDialog
{
// Construction
public:
	CSuDokuSolverDlg(CWnd* pParent = NULL);	// standard constructor
	void CSuDokuSolverDlg::CopyDialogueToSuDoku(CSuDoku& sudoku);
	void CSuDokuSolverDlg::CopySuDokuToDialogue(CSuDoku& sudoku);
	CString GetInStringFromValue(int i);
	CString GetOutStringFromValue(int i);
	GetValueFromString(const CString& str);
	void ActuallyClearEverything();
	void SetTestPuzzle(int iStartingValues[9][9]);
	void ActuallySetTestPuzzle(int iStartingValues[9][9]);
	void ClearHistory();
	BOOL WriteStringToClipboard(const CString& str);
	void WriteLineToString(CString& strBigString, const CString& strStringToAppend);

// Dialog Data
	//{{AFX_DATA(CSuDokuSolverDlg)
	enum { IDD = IDD_SUDOKUSOLVER_DIALOG };
	CListBox	m_ctlOutputListBox;
	CString	m_strCompleteness;
	CString	m_strConsistency;
	CString	m_strIn0_0;
	CString	m_strIn0_1;
	CString	m_strIn0_2;
	CString	m_strIn0_3;
	CString	m_strIn0_4;
	CString	m_strIn0_5;
	CString	m_strIn0_6;
	CString	m_strIn0_7;
	CString	m_strIn0_8;
	CString	m_strIn1_0;
	CString	m_strIn1_1;
	CString	m_strIn1_2;
	CString	m_strIn1_3;
	CString	m_strIn1_4;
	CString	m_strIn1_5;
	CString	m_strIn1_6;
	CString	m_strIn1_7;
	CString	m_strIn1_8;
	CString	m_strIn2_0;
	CString	m_strIn2_1;
	CString	m_strIn2_2;
	CString	m_strIn2_3;
	CString	m_strIn2_4;
	CString	m_strIn2_5;
	CString	m_strIn2_6;
	CString	m_strIn2_7;
	CString	m_strIn2_8;
	CString	m_strIn3_0;
	CString	m_strIn3_1;
	CString	m_strIn3_2;
	CString	m_strIn3_3;
	CString	m_strIn3_4;
	CString	m_strIn3_5;
	CString	m_strIn3_6;
	CString	m_strIn3_7;
	CString	m_strIn3_8;
	CString	m_strIn4_0;
	CString	m_strIn4_1;
	CString	m_strIn4_2;
	CString	m_strIn4_3;
	CString	m_strIn4_4;
	CString	m_strIn4_5;
	CString	m_strIn4_6;
	CString	m_strIn4_7;
	CString	m_strIn4_8;
	CString	m_strIn5_0;
	CString	m_strIn5_1;
	CString	m_strIn5_2;
	CString	m_strIn5_3;
	CString	m_strIn5_4;
	CString	m_strIn5_5;
	CString	m_strIn5_6;
	CString	m_strIn5_7;
	CString	m_strIn5_8;
	CString	m_strIn6_0;
	CString	m_strIn6_1;
	CString	m_strIn6_2;
	CString	m_strIn6_3;
	CString	m_strIn6_4;
	CString	m_strIn6_5;
	CString	m_strIn6_6;
	CString	m_strIn6_7;
	CString	m_strIn6_8;
	CString	m_strIn7_0;
	CString	m_strIn7_1;
	CString	m_strIn7_2;
	CString	m_strIn7_3;
	CString	m_strIn7_4;
	CString	m_strIn7_5;
	CString	m_strIn7_6;
	CString	m_strIn7_7;
	CString	m_strIn7_8;
	CString	m_strIn8_0;
	CString	m_strIn8_1;
	CString	m_strIn8_2;
	CString	m_strIn8_3;
	CString	m_strIn8_4;
	CString	m_strIn8_5;
	CString	m_strIn8_6;
	CString	m_strIn8_7;
	CString	m_strIn8_8;
	CString	m_strOut0_0;
	CString	m_strOut0_1;
	CString	m_strOut0_2;
	CString	m_strOut0_3;
	CString	m_strOut0_4;
	CString	m_strOut0_5;
	CString	m_strOut0_6;
	CString	m_strOut0_7;
	CString	m_strOut0_8;
	CString	m_strOut1_0;
	CString	m_strOut1_1;
	CString	m_strOut1_2;
	CString	m_strOut1_3;
	CString	m_strOut1_4;
	CString	m_strOut1_5;
	CString	m_strOut1_6;
	CString	m_strOut1_7;
	CString	m_strOut1_8;
	CString	m_strOut2_0;
	CString	m_strOut2_1;
	CString	m_strOut2_2;
	CString	m_strOut2_3;
	CString	m_strOut2_4;
	CString	m_strOut2_5;
	CString	m_strOut2_6;
	CString	m_strOut2_7;
	CString	m_strOut2_8;
	CString	m_strOut3_0;
	CString	m_strOut3_1;
	CString	m_strOut3_2;
	CString	m_strOut3_3;
	CString	m_strOut3_4;
	CString	m_strOut3_5;
	CString	m_strOut3_6;
	CString	m_strOut3_7;
	CString	m_strOut3_8;
	CString	m_strOut4_0;
	CString	m_strOut4_1;
	CString	m_strOut4_2;
	CString	m_strOut4_3;
	CString	m_strOut4_4;
	CString	m_strOut4_5;
	CString	m_strOut4_6;
	CString	m_strOut4_7;
	CString	m_strOut4_8;
	CString	m_strOut5_0;
	CString	m_strOut5_1;
	CString	m_strOut5_2;
	CString	m_strOut5_3;
	CString	m_strOut5_4;
	CString	m_strOut5_5;
	CString	m_strOut5_6;
	CString	m_strOut5_7;
	CString	m_strOut5_8;
	CString	m_strOut6_0;
	CString	m_strOut6_1;
	CString	m_strOut6_2;
	CString	m_strOut6_3;
	CString	m_strOut6_4;
	CString	m_strOut6_5;
	CString	m_strOut6_6;
	CString	m_strOut6_7;
	CString	m_strOut6_8;
	CString	m_strOut7_0;
	CString	m_strOut7_1;
	CString	m_strOut7_2;
	CString	m_strOut7_3;
	CString	m_strOut7_4;
	CString	m_strOut7_5;
	CString	m_strOut7_6;
	CString	m_strOut7_7;
	CString	m_strOut7_8;
	CString	m_strOut8_0;
	CString	m_strOut8_1;
	CString	m_strOut8_2;
	CString	m_strOut8_3;
	CString	m_strOut8_4;
	CString	m_strOut8_5;
	CString	m_strOut8_6;
	CString	m_strOut8_7;
	CString	m_strOut8_8;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSuDokuSolverDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CSuDoku m_sudoku;

	// Generated message map functions
	//{{AFX_MSG(CSuDokuSolverDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void EnsureAppropriateThingsUpdated();
	afx_msg void OnBsolve();
	afx_msg void OnBcleareverything();
	afx_msg void OnBtestpuzzle1();
	afx_msg void OnBtestpuzzle99();
	afx_msg void OnBtestpuzzle30();
	afx_msg void OnBtestpuzzle74();
	afx_msg void OnBultrahard();
	afx_msg void OnBcopytoclipboard();
	afx_msg void OnBabout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SUDOKUSOLVERDLG_H__4055FB5E_8BCA_43FE_86CC_4713606F6CE9__INCLUDED_)
